import numpy as np
import matplotlib.pyplot as plt

#------------------------------------------------

def dsolve_Euler(f,x0,t):
   
    N=x0.shape[0]
    Nt=t.shape[0]
    
    x=np.zeros((Nt,N))
    x[0,:]=x0

    for j in range(Nt-1):
        h=t[j+1]-t[j]
        x[j+1,:]=x[j,:]+h*np.array(f(x[j,:],t[j]))
        
    return x

#------------------------------------------------

def fun(x,t): return [x[0],-x[1]]
    
Nstep=20
tmax=1.0

x0=np.array([1.0,1.0])
t=np.linspace(0.0,tmax,Nstep+1)

x=dsolve_Euler(fun,x0,t)
print(x[Nstep,:])

# exact result for the last point
print(np.exp([1,-1]))

# plot exact and numerical ode solution
t2=np.linspace(0.0,tmax,1000)
plt.plot(t2,np.exp(t2),'r-',t2,np.exp(-t2),'b-',t,x[:,0],'r.',t,x[:,1],'b.')
plt.show()
