import numpy as np
import matplotlib.pyplot as plt
import scipy.integrate

#------------------------------------------------

def fun(x,t): return [x[0],-x[1]]

Nstep=20
tmax=1.0

x0=np.array([1.0,1.0])
t=np.linspace(0.0,tmax,Nstep+1)

x=scipy.integrate.odeint(fun,x0,t)
print(x[Nstep,:])

# exact result for the last point
print(np.exp([1,-1]))

# plot exact and numerical ode solution
t2=np.linspace(0.0,tmax,1000)
plt.plot(t2,np.exp(t2),'r-',t2,np.exp(-t2),'b-',t,x[:,0],'r.',t,x[:,1],'b.')
plt.show()
